aboutsummaryrefslogtreecommitdiffstats
path: root/scripts/gen-dependencies.sh
diff options
context:
space:
mode:
Diffstat (limited to 'scripts/gen-dependencies.sh')
-rwxr-xr-xscripts/gen-dependencies.sh33
1 files changed, 33 insertions, 0 deletions
diff --git a/scripts/gen-dependencies.sh b/scripts/gen-dependencies.sh
new file mode 100755
index 0000000..c6b6f75
--- /dev/null
+++ b/scripts/gen-dependencies.sh
@@ -0,0 +1,33 @@
+#!/usr/bin/env bash
+#
+# Copyright (C) 2012 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+SELF=${0##*/}
+
+READELF="${READELF:-readelf}"
+OBJCOPY="${OBJCOPY:-objcopy}"
+TARGETS=$*
+XARGS="${XARGS:-xargs -r}"
+
+[ -z "$TARGETS" ] && {
+ echo "$SELF: no directories / files specified"
+ echo "usage: $SELF [PATH...]"
+ exit 1
+}
+
+find $TARGETS -type f -a -exec file {} \; | \
+ sed -n -e 's/^\(.*\):.*ELF.*\(executable\|shared object\).*,.* stripped/\1/p' | \
+ $XARGS -n1 $READELF -d | \
+ awk '$2 ~ /NEEDED/ && $NF !~ /interpreter/ && $NF ~ /^\[?lib.*\.so/ { gsub(/[\[\]]/, "", $NF); print $NF }' | \
+ sort -u
+
+tmp=`mktemp $TMP_DIR/dep.XXXXXXXX`
+for kmod in `find $TARGETS -type f -name \*.ko`; do
+ $OBJCOPY -O binary -j .modinfo $kmod $tmp
+ sed -e 's,\x00,\n,g' $tmp | \
+ sed -ne '/^depends=.\+/ { s/^depends=//; s/,/.ko\n/g; s/$/.ko/p; q }'
+done | sort -u
+rm -f $tmp